liamfallon | 81c2c51 | 2021-12-16 12:56:37 +0000 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | |
| 3 | # |
| 4 | # ============LICENSE_START================================================ |
| 5 | # ONAP |
| 6 | # ========================================================================= |
| 7 | # Copyright (C) 2021-2022 Nordix Foundation. |
| 8 | # ========================================================================= |
| 9 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 10 | # you may not use this file except in compliance with the License. |
| 11 | # You may obtain a copy of the License at |
| 12 | # |
| 13 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 14 | # |
| 15 | # Unless required by applicable law or agreed to in writing, software |
| 16 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 17 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 18 | # See the License for the specific language governing permissions and |
| 19 | # limitations under the License. |
| 20 | # ============LICENSE_END================================================== |
| 21 | # |
| 22 | |
liamfallon | d7d9a66 | 2022-03-01 21:01:03 +0000 | [diff] [blame] | 23 | SCRIPT_NAME=$(basename "$0") |
liamfallon | 81c2c51 | 2021-12-16 12:56:37 +0000 | [diff] [blame] | 24 | repo_location="./" |
| 25 | release_data_file="./pf_release_data.csv" |
| 26 | |
| 27 | usage() |
| 28 | { |
| 29 | echo "" |
| 30 | echo "$SCRIPT_NAME - release the specified repository by generating the release yaml file and the release commit" |
| 31 | echo "" |
| 32 | echo " usage: $SCRIPT_NAME [-options]" |
| 33 | echo "" |
| 34 | echo " options" |
| 35 | echo " -h - this help message" |
| 36 | echo " -d data_file - the policy release data file to use, defaults to '$release_data_file'" |
| 37 | echo " -l location - the location of the policy framework repos on the file system," |
| 38 | echo " defaults to '$repo_location'" |
| 39 | echo " -r repo - the policy repo to release" |
| 40 | echo " -i issue-id - issue ID in the format POLICY-nnnn" |
| 41 | echo "" |
| 42 | echo " examples:" |
| 43 | echo " $SCRIPT_NAME -l /home/user/onap -d /home/user/data/pf_release_data.csv -r policy/common -i POLICY-1234" |
| 44 | echo " release the 'policy/common' repo at location '/home/user/onap' using the release data" |
| 45 | echo " in the file '/home/user/data/pf_release_data.csv'" |
| 46 | exit 255; |
| 47 | } |
| 48 | |
| 49 | while getopts "hd:l:r:i:" opt |
| 50 | do |
| 51 | case $opt in |
| 52 | h) |
| 53 | usage |
| 54 | ;; |
| 55 | d) |
| 56 | release_data_file=$OPTARG |
| 57 | ;; |
| 58 | l) |
| 59 | repo_location=$OPTARG |
| 60 | ;; |
| 61 | r) |
| 62 | specified_repo=$OPTARG |
| 63 | ;; |
| 64 | i) |
| 65 | issue_id=$OPTARG |
| 66 | ;; |
| 67 | \?) |
| 68 | usage |
| 69 | exit 1 |
| 70 | ;; |
| 71 | esac |
| 72 | done |
| 73 | |
| 74 | if [ $OPTIND -eq 1 ] |
| 75 | then |
| 76 | echo "no arguments were specified" |
| 77 | usage |
| 78 | fi |
| 79 | |
| 80 | if [[ -z "$repo_location" ]] |
| 81 | then |
| 82 | echo "policy repo location not specified on -l flag" |
| 83 | exit 1 |
| 84 | fi |
| 85 | |
| 86 | if ! [ -d "$repo_location" ] |
| 87 | then |
| 88 | echo "policy repo location '$repo_location' not found" |
| 89 | exit 1 |
| 90 | fi |
| 91 | |
| 92 | if [[ -z "$release_data_file" ]] |
| 93 | then |
| 94 | echo "policy release data file not specified on -d flag" |
| 95 | exit 1 |
| 96 | fi |
| 97 | |
| 98 | if ! [ -f "$release_data_file" ] |
| 99 | then |
| 100 | echo "policy release data file '$release_data_file' not found" |
| 101 | exit 1 |
| 102 | fi |
| 103 | |
| 104 | if [ -z "$specified_repo" ] |
| 105 | then |
| 106 | echo "repo not specified on -r flag" |
| 107 | exit 1 |
| 108 | fi |
| 109 | |
| 110 | if [ -z "$issue_id" ] |
| 111 | then |
| 112 | echo "issue_id not specified on -i flag" |
| 113 | exit 1 |
| 114 | fi |
| 115 | |
| 116 | if ! echo "$issue_id" | grep -Eq '^POLICY-[0-9]*$' |
| 117 | then |
| 118 | echo "issue ID is invalid, it should be of form 'POLICY-nnnn'" |
| 119 | exit 1 |
| 120 | fi |
| 121 | |
liamfallon | d7d9a66 | 2022-03-01 21:01:03 +0000 | [diff] [blame] | 122 | # shellcheck disable=SC2034 |
| 123 | # shellcheck disable=SC2046 |
| 124 | read -r repo \ |
liamfallon | 81c2c51 | 2021-12-16 12:56:37 +0000 | [diff] [blame] | 125 | latest_released_tag \ |
| 126 | latest_snapshot_tag \ |
liamfallon | d7d9a66 | 2022-03-01 21:01:03 +0000 | [diff] [blame] | 127 | changed_files \ |
| 128 | docker_images \ |
| 129 | <<< $(grep "$specified_repo" "$release_data_file" | tr ',' ' ' ) |
liamfallon | 81c2c51 | 2021-12-16 12:56:37 +0000 | [diff] [blame] | 130 | |
| 131 | if [ ! "$repo" = "$specified_repo" ] |
| 132 | then |
| 133 | echo "repo '$specified_repo' not found in file 'pf_release_data.csv'" |
| 134 | exit 1 |
| 135 | fi |
| 136 | |
| 137 | next_release_version=${latest_snapshot_tag%-*} |
| 138 | |
| 139 | while true |
| 140 | do |
liamfallon | 41fc725 | 2022-04-13 18:23:43 +0100 | [diff] [blame] | 141 | read -r -p "have you run 'stage-release' on the '$repo' repo? " yes_no |
liamfallon | 81c2c51 | 2021-12-16 12:56:37 +0000 | [diff] [blame] | 142 | case $yes_no in |
| 143 | [Yy]* ) break |
| 144 | ;; |
| 145 | |
| 146 | [Nn]* ) exit |
| 147 | ;; |
| 148 | |
| 149 | * ) echo "Please answer 'yes' or 'no'" |
| 150 | ;; |
| 151 | esac |
| 152 | done |
| 153 | |
liamfallon | d7d9a66 | 2022-03-01 21:01:03 +0000 | [diff] [blame] | 154 | saved_current_dir=$(pwd) |
| 155 | cd "$repo_location/$repo" || exit 1 |
liamfallon | 81c2c51 | 2021-12-16 12:56:37 +0000 | [diff] [blame] | 156 | if [ "$docker_images" != "" ] |
| 157 | then |
liamfallon | d7d9a66 | 2022-03-01 21:01:03 +0000 | [diff] [blame] | 158 | mkart_flag="-d" |
liamfallon | 81c2c51 | 2021-12-16 12:56:37 +0000 | [diff] [blame] | 159 | else |
liamfallon | d7d9a66 | 2022-03-01 21:01:03 +0000 | [diff] [blame] | 160 | mkart_flag="" |
liamfallon | 81c2c51 | 2021-12-16 12:56:37 +0000 | [diff] [blame] | 161 | fi |
liamfallon | d7d9a66 | 2022-03-01 21:01:03 +0000 | [diff] [blame] | 162 | |
| 163 | if ! mkart.sh "$mkart_flag" |
| 164 | then |
| 165 | echo "generation of artifact release yaml file failed" |
| 166 | cd "$saved_current_dir" || exit 1 |
| 167 | exit 1 |
| 168 | fi |
| 169 | |
| 170 | cd "$saved_current_dir" || exit 1 |
liamfallon | 81c2c51 | 2021-12-16 12:56:37 +0000 | [diff] [blame] | 171 | |
| 172 | echo "generating commit for $repo release: $latest_released_tag-->$next_release_version . . ." |
| 173 | |
| 174 | generateCommit.sh \ |
liamfallon | d7d9a66 | 2022-03-01 21:01:03 +0000 | [diff] [blame] | 175 | -l "$repo_location" \ |
| 176 | -r "$repo" \ |
| 177 | -i "$issue_id" \ |
liamfallon | 81c2c51 | 2021-12-16 12:56:37 +0000 | [diff] [blame] | 178 | -e "Release $repo: $next_release_version" \ |
| 179 | -m "This commit releases repo $repo." |
| 180 | |
| 181 | echo "commit for $repo release: $latest_released_tag-->$next_release_version generated" |